<!--
  ~ Benchmarking Suite
  ~ Copyright 2014-2022 Engineering Ingegneria Informatica S.p.A.
  ~
  ~ Licensed under the Apache License, Version 2.0 (the "License");
  ~ you may not use this file except in compliance with the License.
  ~ You may obtain a copy of the License at
  ~
  ~ http://www.apache.org/licenses/LICENSE-2.0
  ~
  ~ Unless required by applicable law or agreed to in writing, software
  ~ distributed under the License is distributed on an "AS IS" BASIS,
  ~ WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  ~ See the License for the specific language governing permissions and
  ~ limitations under the License.
  -->

<template>

  <v-container>

    <span>
      <button v-on:click="$emit('up')">EasyCloud</button>
    </span>

    <span>
      &gt;
      <button v-on:click="workload=null; edit=false">Workloads</button>
    </span>

    <span v-if="workload">
      &gt;
      <button>{{workload.name + ' (' + workload.tool + ')'}}</button>
    </span>

    <v-divider/>

    <WorkloadsList
      v-if = "(workload==null || workload.id==null) && !edit"
      v-on:selected="workload=$event"
      v-on:edit="edit=true; workload=$event"
    />

    <WorkloadViewer
      :workloadId="workload.id"
      v-if="workload && workload.id && !edit"
      v-on:selected="edit=false; workload=$event"
      v-on:edit="edit=true; workload=$event"
      v-on:deleted="edit=false; workload=null"
      v-on:clone="edit=true; workload=$event; workload.id=null; workload.name='Copy of '+workload.name; workload.grants={owner:'me'}"
    />

    <WorkloadEditor
      :workloadTemplate = "workload"
      v-if="workload!=null && edit==true"
      v-on:view="edit=false; workload=$event"
      v-on:selected="edit=false; workload=$event"
    />

  </v-container>

</template>

<script>

import WorkloadsList from './WorkloadsList.vue';
import WorkloadViewer from './WorkloadViewer.vue';
import WorkloadEditor from './WorkloadEditor.vue';

export default {

  name: 'WorkloadsMain',

  components: {
    WorkloadsList,
    WorkloadViewer,
    WorkloadEditor
  },
  data: () => ({
    workload: null,
    edit: false
  })

};

</script>
